#include <bits/stdc++.h>

using namespace std;

int main()
{
    int m, n;
    cin >> m >> n;
    int a[n], b[n], t[n];
    for(int i = 0; i < n; i++)
    {
        cin >> a[i] >> b[i] >> t[i];
    }
    int u, v;
    cin >> u >> v;
    bool k = false;
    int br = 1;
    for(int i = 0; i < m; i++)
    {
        if(v==b[i])
        { 
            v=a[i];
            if(t[i]==1&&k==false)
            {
                k = true;
                br++;
            }
            else if(t[i]==0&&k==true)
            {
                k = false;
                br++;
            }
            if(v==u)
            {
            	cout << br;
            	return 0;
			}
			i = 0;
        }
    }
}